#include "mars.h"

class NodeSelectionUD : public Obj {
private:
    ndLst *ndL;
    double czCut;
public:
    NodeSelectionUD () : ndL(NULL), czCut(0.) { init0(); }
    NodeSelectionUD (string nm) : Obj(nm), ndL(NULL), czCut(0.) { init0(); }
    void init0() { type = UDOBJ; }
    void init();
    virtual bool processCommand(Reader *, string);
    virtual void execUserDefinedCommand(Object *);
};

bool NodeSelectionUD::processCommand (Reader *rdr, string lbl) {
    Lists *lists = (Lists *)lst;
    if (lbl == "NodeList") {
        string nam = rdr->getShortLabel();
        ndL = (ndLst*)lists->findLst(nam, NDLST);
        if (ndL == NULL) {
            stringstream ss;
            ss << "Cannot find node list - " << nam;
            rdr->error(ss);
        }
    } else if (lbl == "cz") {
        czCut = rdr->readLength();
    } else if (Obj::processCommand(rdr, lbl)) {
    } else 
        return false;
    return true;
}

void NodeSelectionUD::init () { // called right after its input is read
}

void NodeSelectionUD::execUserDefinedCommand (Object *caller) {
    ndL = (ndLst*)caller; // cast caller to what it is
    int nnd = ndL->getNumber();
    ndL->unselectAll(); // do as necessary
    Node **nd = (Node**)ndL->getObjectListPointer();
    for (int i=0; i<nnd; i++) {
        double cz = nd[i]->getCz();
        if (cz > czCut)
            nd[i]->select();
    }
}

// --------------------------------------------------------------------
// createUserDefinedList(...) and readRstUserDefineList(...)
// must always be defined

obLst *Model::createUserDefinedList (string nam, Reader *rdr) {
    return NULL;
}

obLst *Model::readRstUserDefinedList (RstReader *rst, string nam) {
    return NULL;
}

// --------------------------------------------------------------------
// createUserDefinedObject(...) and readRstUserDefinedObject(...)
// must always be defined

Obj *Model::createUserDefinedObject (string nam, Reader *rdr) {
    string lbl = rdr->getShortLabel();
    if (lbl == "NodeSelectionUD")
        return new NodeSelectionUD(nam);
    return NULL;
}

Obj *Model::readRstUserDefinedObject (RstReader *rst, string nam) {
    return NULL;
}
